package com.usky.dxtop.controller.web;

import com.usky.dxtop.service.api.TopApiConfiger;
import com.usky.dxtop.service.api.WxApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.TreeMap;

/**
 * @author yq
 * @date 2021/9/22 10:04
 */
@Slf4j
@RestController
public class WxController {

    @Autowired
    private TopApiConfiger topApiConfiger;

    @Autowired
    private WxApi wxApi;
    @GetMapping("/wxLogin")
    public String wxLogin(@RequestParam String jsCode,@RequestParam Integer type){
        if (1 == type){
            return wxApi.wxLogin(topApiConfiger.getWxAppId(),topApiConfiger.getWxAppSecret(),jsCode);
        }else {
            return wxApi.wxLogin(WxApi.APP_ID,WxApi.SECRET,jsCode);
        }
    }

    /**
     * 拉起支付
     * @param url
     * @return
     */
    @GetMapping("/wxAccToken")
    public TreeMap<String, String> getAccToken(@RequestParam String url){
        return wxApi.getPayParam(topApiConfiger.getWxAppId(),topApiConfiger.getWxAppSecret(),url);
    }

    /**
     * 获取token
     * @return
     */
    @GetMapping("/accentToken")
    public String getToken(@RequestParam Integer type){
        if (1 == type){
            return wxApi.getToken(topApiConfiger.getWxAppId(),topApiConfiger.getWxAppSecret());
        }else {
            return wxApi.getToken(WxApi.APP_ID,WxApi.SECRET);
        }
    }

    /**
     * 公众号进行消息推送
     * @param openId
     * @param data
     * @param templateId
     * @param detailUrl
     * @return
     */
    @GetMapping("/offSendMessage")
    public String offSendMessageT(@RequestParam String openId,
                                  @RequestParam Object data,
                                  @RequestParam String templateId,
                                  @RequestParam(required = false) String detailUrl){
        return wxApi.sendMessageApi(openId,data,wxApi.getToken(WxApi.APP_ID,WxApi.SECRET),templateId,detailUrl);
    }
}
